    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.modules;
    020
    021import java.util.Collection;
    022
    023
    024public interface ModuleManager {
    025
    026    /** Location of the property-files of plugins. (Each plugin should include this property-file in its jar-file) */
    027    String PLUGIN_RESOURCE_LOCATION = "ini/jspwiki_module.xml";
    028
    029    String PLUGIN_I18N_RESOURCE = "plugin/PluginResources";
    030
    031    /**
    032     *  Returns true, if the given module is compatible with this version of JSPWiki.
    033     *
    034     *  @param info The module to check
    035     *  @return True, if the module is compatible.
    036     */
    037    boolean checkCompatibility( WikiModuleInfo info );
    038
    039    /**
    040     * Returns the {@link WikiModuleInfo} information about the provided moduleName.
    041     *
    042     * @param moduleName
    043     * @return The wikiModuleInfo
    044     */
    045    WikiModuleInfo getModuleInfo( String moduleName );
    046
    047    /**
    048     * Returns a collection of modules currently managed by this ModuleManager.  Each
    049     * entry is an instance of the WikiModuleInfo class.  This method should return something
    050     * which is safe to iterate over, even if the underlying collection changes.
    051     *
    052     * @return A Collection of WikiModuleInfo instances.
    053     */
    054    Collection< WikiModuleInfo > modules();
    055
    056}